<!DOCTYPE HTML>
<html>
<head>
  <title>Graph2d | Scrolling and Sorting</title>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/vis/4.21.0/vis.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/vis/4.21.0/vis.min.css">

  <script type="text/javascript" src="https://unpkg.com/alasql@4.1.2/dist/alasql.min.js"></script>

  <script type="module">
	  import * as d3 from "https://cdn.jsdelivr.net/npm/d3@7/+esm";
  </script>
</head>
<body>
  <script type="text/javascript" src="./javascript/alasqlExtensions.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/three.js/0.147.0/three.min.js"></script>
  <script type="text/javascript" src="./javascript/createTables.js"></script>
  <script type="text/javascript" src="./javascript/parseLog.js"></script>
  <script type="text/javascript" src="./javascript/csv2json.js"></script>
  <script>
    createTables()
    var baseTrackURL="https://github.com/aws-deepracer/aws-deepracer-workshops/raw/master/log-analysis/tracks/reinvent_base.npy"
    var sampleLogURL="https://raw.githubusercontent.com/aws-deepracer-community/deepracer-analysis/master/logs/sample-console-logs/logs/evaluation/evaluation-20220612082853-IBZwYd0MRMqgwKlAe7bb0A-robomaker.log"
  </script>
  <h2>load</h2>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/handsontable/dist/handsontable.full.min.css" />
  <script type="text/javascript" src="https://cdn.jsdelivr.net/npm/handsontable/dist/handsontable.full.min.js"></script>


  <input name="local file:" type="file" id="myFile">
  <div>
    <input name="URL:" type="url" id="inputURL"/>
    <input  type="button" value="load URL" onclick="loadURL('inputURL','output');"/>
  </div>
  <div>
    <input type="button" value="graph data" onclick="graphData();"/>
  </div>

  <div id="resData">no data</div>
  <textarea style="width:500px;height: 400px" id="output"></textarea>
  <script>
    const inputURL = document.getElementById("inputURL");
    inputURL.value=sampleLogURL;
    function AWSArray(e,graph){
      alasql('SELECT * FROM CSV(?,{headers:true,separator:","})', [e.target.result],(data)=>{
          console.log("load AWSArray" )
          output.value=JSON.stringify(data)
          alasql('SELECT top 20 * INTO HTML("#resData",{headers:true}) FROM ? ',[data])

          graphDataVIS(data)
        });
    }
    const input = document.getElementById("myFile");
    const output = document.getElementById("output");
    input.addEventListener("change", function () {
      const dataTypeFunction=AWSArray;
      if (this.files && this.files[0]) {
        let myFile = this.files[0];
        let reader = new FileReader();
        reader.addEventListener('load', function (e) {
        output.textContent = e.target.result;
        dataTypeFunction(e,graph)
      });
      reader.readAsBinaryString(myFile);
    }
  });
  </script>

<h2>Graph</h2>
<div style="width:700px; font-size:14px; text-align: justify;"></div>
<div id="visualization"></div>
<div id="visualizationDot"></div>

<script type="text/javascript">
  var dataSet = new vis.DataSet();
  const container = document.getElementById('visualization');
  let steps = 500;
  const axisMax = 314, tmax = 4 * 2 * Math.PI, axisStep = axisMax / steps, tmaxSteps = tmax / steps, r = 1;
  for (let t = 0; t < tmax; t += tmaxSteps) {
    dataSet.add({ x: r * Math.sin(t), y: r * Math.cos(t), z: t / tmax, style:t  });
  }
  const tooltip= function (point) {
          // parameter point contains properties x, y, z, and data
          // data is the original object passed to the point constructor
          return 'x:' + point.x + '<br>'+'y:' + point.y +'<br>'+'epidose:' + point.z + '<br> reward : '+ point.data.style
        }
  const tooltipStyle= {
          content: {
            background    : 'rgba(255, 255, 255, 0.7)',
            padding       : '10px',
            borderRadius  : '10px'
          },
          line: {
            borderLeft    : '1px dotted rgba(0, 0, 0, 0.5)'
          },
          dot: {
            border        : '5px solid rgba(0, 0, 0, 0.5)'
          }
        }
  const optionsDot = {
    width: "600px",
    height: "600px",
    style: "dot-size",
    showPerspective: true,
    showGrid: true,
    keepAspectRatio: true,
    verticalRatio: 1.0,
    animationInterval: 1000, // milliseconds
    animationPreload: false,
    animationAutoStart: true,
    legendLabel: "episode",
    cameraPosition: {
      horizontal: 2.7,
      vertical: 0.0,
      distance: 1.65,
    },
    tooltip:tooltip,tooltipStyle:tooltipStyle
  };

  const options = {
    width: '600px',
    height: '600px',
    style: 'line',
    showPerspective: false,
    showGrid: true,
    keepAspectRatio: true,
    verticalRatio: 1.0,
    tooltip:true
  };

  var graph = new vis.Graph3d(container, dataSet, options);
  graph.setCameraPosition(0.4, undefined, undefined);

  const containerDot = document.getElementById('visualizationDot');
  const dataView = new vis.DataView(dataSet, {filter:(d)=>d.z})
  var dataSetDot = new vis.DataSet(dataView.get());
  var graphDot = new vis.Graph3d(containerDot, dataSet, optionsDot);
  graphDot.setCameraPosition(0.4, undefined, undefined);
 
 </script>

<h2>graphing</h2>
<input id="graphData" type="button" value="graph json data" onclick="graphData();"/>
<input type="button" value="graph log data" onclick="graphDataINTO();"/>
<input type="button" value="graph delta" onclick="showDeltas()"/>
<div id="resDataDelta">no data delta</div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js"></script>
<script>
  function showDeltas(){
    alasql('SELECT * FROM log', [],(logdata)=>{
          console.log("load dif" )
          const data=generateDiffLog(logdata); 
          alasql('SELECT top 20 * INTO HTML("#resData",{headers:true}) FROM ? ',[data])
          alasql('SELECT `* INTO logdiffs FROM ?',[data])
          alasql('SELECT * INTO VISJSGRAPH(?) from logdiffs')
    });
  }
  function loadURL(source,target="output") {
    const inputURL = document.getElementById(source);
    jQuery.ajax({
                "crossDomain": true,
                "url": inputURL.value,
                "method": "GET"
      }).done(function (response) {
        const output = document.getElementById(target);
        output.value=response;
        console.log("data loaded from "+inputURL.value)
      }).error(()=>alert("error loading "+inputURL.value));
  }

  function graphData(){
    if(!output.value) throw Error("No data in text area")
    if(output.value.substr(0,1)=="[") {
      graphDataVIS(JSON.parse(output.value))
      return
    } 
    parseLog(output.value,(data)=>{
      if(data.length==0){
        alert("parseLog do rows")
        throw Error("no data")
      } 
      graphDataVIS(data)
    })
  }
  function graphDataINTO(){
    parseLog(output.value,(data)=>{
      alasql('SELECT * INTO log FROM ?',[data])
      alasql('SELECT x,y,episode as z, reward as style INTO VISJSGRAPH(?) from log',[{graph:graphDot,filter:(r)=>r.z}])
    })
  }

  function generateDiffLog(sourceData){
    if(!data) throw Error("no data")
    data= typeof sourceData == "string" ? JSON.parse(sourceData) : sourceData
    const r=[];
    const l=data.length;
    for(let i=1;i<l;i++){
      const ri=data[i]
      const rj=data[i-1]
      const row={
        eposide:rj.episode,
        step:rj.step,
        x:rj.x,
        y:rj.x,
        heading:rj.heading-ri.heading,
        steering_angle: rj.steering_angle- ri.steering_angle,
        speed: rj.speed - ri.speed,
        action_taken: rj.action_taken - ri.action_taken,
        reward : rj.reward,
        current_progress: rj.current_progress - ri.DataSet,
      }
      r.push(row)
    }
    return r
  }
  function graphDataVIS(data,targets=[graph,graphDot]){
      alasql('SELECT top 20 * INTO HTML("#resData",{headers:true}) FROM ? ',[data])
      alasql('SELECT coalesce(step,steps,0) as z ,coalesce(X,x,0) as x, coalesce(Y,y,0) as y , reward as style INTO VISJSGRAPH(?) FROM ? order by episode,step',[[graph,graphDot],data])
  }
</script>

<h1>track</h1>
<script>
  function graphTrack(){
    const trackData = document.getElementById("trackOutput");
    if(!trackData.value) throw Error("trackOutput has no value")
    const data=csv2json(trackData.value,"'")
    alasql('SELECT x1,y1,x2,y2,x3,y3 INTO track FROM ?',[data])
    alasql('SELECT * INTO HTML("#trackData",{headers:true}) FROM track ')
    alasql('SELECT id,1 as style,x,y,0 as z INTO VISJSGRAPH(?) FROM (select id, x1 as x, y1 as y from track union select 1000000+id as id, x2 as x, y2 as y from track union select 2000000+id as id, x3 as x, y3 as y from track) order by id',[{graph:graph,filter:(r)=>r.episode}, graphDot])
  }
</script>
<div>
  <input name="track URL:" type="url" value="./tracks/reinvent_base.csv" id="trackInputURL"/>
  <input  type="button" value="load URL" onclick="loadURL('trackInputURL','trackOutput');"/>
  <input  type="button" value="graph URL" onclick="graphTrack();"/>
</div>
<textarea style="width:500px;height: 400px" id="trackOutput"></textarea>
<div id="trackData">no data</div>

<h1>test echart</h1>

<script type="text/javascript" src="https://fastly.jsdelivr.net/npm/echarts@5.4.3/dist/echarts.min.js"></script>
<script type="text/javascript" src="https://fastly.jsdelivr.net/npm/echarts@5.4.3/dist/extension/dataTool.min.js"></script>
<script type="text/javascript" src="https://fastly.jsdelivr.net/npm/echarts-gl@2/dist/echarts-gl.min.js"></script>
<script type="text/javascript" src="https://fastly.jsdelivr.net/npm/echarts-stat@latest/dist/ecStat.min.js"></script>

<script type="text/javascript" src="./javascript/eChartData.js"></script>
<input  type="button" value="graph eChart" onclick="eChartDiff();"/>
<div id="eChartContainer" style="height: 100%"></div>
<div></div>
<script>
function eChartDiff(){
  alasql('select episode*100+step as x, \'reward\' as y, reward as z into echart(?,?) from logdiffs',["eChartContainer",{xaxis:['reward']}])
  log.console('echart done')
}
</script>
</body>
</html>